//
// $Id: _config.h,v 1.5 2003/07/10 15:31:11 nj Exp $
// This file contains all design-time options
//

// For synthesis, some parts need to be removed
// #define SYNTHESIS

// For cpuwaitgenerator
#define INSERT_WAIT_STATE

// For dataram
#define RAMMEMSIZE 8192

// Size of instruction memory
#define INSTMEMSIZE 8192

// For service_module
// #define CI_ML_XDIV

//
// Debug outputs are defined below
//

// Write init statements, e.g. INIT_REGFILE
#define WRITE_INIT

// Print every instruction as it is executed
#define PRINTINST

// Print memory debug
#define DEBUG_MEMORY

// Print instruction contents every clock cycle
#define PRINTREGFILE

// Print IO instruction debug output
#define PRINTIOREGFILE

// Print register assignments in timer_counter
#define PRINTTC
