//
// $Id: io_adr_dec.h,v 1.3 2003/06/30 18:30:04 nj Exp $
//
#ifndef _IO_ADR_DEC_H
#define _IO_ADR_DEC_H
#include <systemc.h>
#include "config.h"

#include "avrucpackage.h"

SC_MODULE(io_adr_dec)
{
  sc_in<sc_uint<6> > adr;
  sc_in<sc_logic> iore;
  sc_in<sc_lv<8> > dbusin_ext;
  sc_out<sc_lv<8> > dbusin_int;

  sc_in<sc_lv<8> > spl_out;
  sc_in<sc_lv<8> > sph_out;
  sc_in<sc_lv<8> > sreg_out;
  sc_in<sc_lv<8> > rampz_out;

  void execute();

  SC_CTOR(io_adr_dec)
  {
    SC_METHOD(execute);
    sensitive << adr << iore << dbusin_ext << spl_out << sph_out << sreg_out << rampz_out;
  }
};

#endif
