//
// $Id: irq_onehot.h,v 1.1 2003/07/16 19:45:03 nj Exp $
//
#ifndef _IRQ_ONEHOT_H
#define _IRQ_ONEHOT_H
#include <systemc.h>
#include "config.h"
#include "constants.h"

SC_MODULE(irq_onehot)
{
  sc_in<sc_logic> irqack;
  sc_in<sc_lv<5> > irqackad;

  sc_out<sc_logic> irq_onehot_ack0;
  sc_out<sc_logic> irq_onehot_ack1;
  sc_out<sc_logic> irq_onehot_ack2;
  sc_out<sc_logic> irq_onehot_ack3;
  sc_out<sc_logic> irq_onehot_ack4;
  sc_out<sc_logic> irq_onehot_ack5;
  sc_out<sc_logic> irq_onehot_ack6;
  sc_out<sc_logic> irq_onehot_ack7;
  sc_out<sc_logic> irq_onehot_ack8;
  sc_out<sc_logic> irq_onehot_ack9;
  sc_out<sc_logic> irq_onehot_ack10;
  sc_out<sc_logic> irq_onehot_ack11;
  sc_out<sc_logic> irq_onehot_ack12;
  sc_out<sc_logic> irq_onehot_ack13;
  sc_out<sc_logic> irq_onehot_ack14;
  sc_out<sc_logic> irq_onehot_ack15;
  sc_out<sc_logic> irq_onehot_ack16;
  sc_out<sc_logic> irq_onehot_ack17;
  sc_out<sc_logic> irq_onehot_ack18;
  sc_out<sc_logic> irq_onehot_ack19;
  sc_out<sc_logic> irq_onehot_ack20;
  sc_out<sc_logic> irq_onehot_ack21;
  sc_out<sc_logic> irq_onehot_ack22;

  void execute();

  SC_CTOR(irq_onehot)
  {
    SC_METHOD(execute);
    sensitive << irqack << irqackad;
  }
};

#endif
