//
//$Id: nj_mux.cc,v 1.6 2003/08/01 16:43:59 nj Exp $
//
#include "nj_mux.h"

//
// Multiplextor...no registers besides io_reg
//
// sensitive << dbusin_ram << iore << ramre << adr
// sensitive << ALL io_register values.....
void nj_mux::execute()
{
  sc_lv<8> v_dbusout;

  if (iore.read() == 1)
    {
      if ((adr.read() == 35) || (adr.read() == 36) || (adr.read() == 37) || (adr.read() == 38) ||
	  (adr.read() == 39) || (adr.read() == 40) || (adr.read() == 41) || (adr.read() == 42) ||
	  (adr.read() == 43) || (adr.read() == 44) || (adr.read() == 45) || (adr.read() == 46) ||
	  (adr.read() == 47) || (adr.read() == 48) || (adr.read() == 49) || (adr.read() == 50) ||
	  (adr.read() == 51) || (adr.read() == 54) || (adr.read() == 55))
	v_dbusout = dbusin_tc.read();
      else if ((adr.read() == 52) || (adr.read() == 53) || (adr.read() == 56) ||
	       (adr.read() == 57) || (adr.read() == 58) || (adr.read() == 60))
	v_dbusout = dbusin_sm.read();
      else
	v_dbusout = io_registers[adr.read()];
#ifdef PRINTIOREGFILE
      /*
      cout << "nj_mux::execute()" << endl;
      cout << "dbusout = " << v_dbusout << endl;
      */
#endif
    }
  else if (ramre.read() == 1)
    {
      v_dbusout = dbusin_ram.read();
    }
  else
    {
      v_dbusout = "00000000";
    }

  dbusout = v_dbusout;
}

//
// Write IO registers
//
// sensitive_neg << clk
void nj_mux::writeregs()
{
  if (iowe.read() == 1)
    {
      io_registers[adr.read()] = dbusin_avr;
#ifdef PRINTIOREGFILE
      cout << "nj_mux::writeregs()" << endl;
      cout << "io_registers[" << adr.read() << "] = " << dbusin_avr.read() << endl;
#endif
    }
}
