// -- Written by VHDL2SystemC
// --  input: uart.vhd

#ifndef _VHDL2SYSTEMC_uart_rtl_H
#define _VHDL2SYSTEMC_uart_rtl_H
#include "vhdl2systemc.h"

#include "avrucpackage.h"

SC_MODULE(uart_rtl)
{
  sc_in<sc_logic> ireset;
  sc_in<sc_logic> cp2;
  sc_in<sc_lv<6> > adr;
  sc_in<sc_lv<8> > dbus_in;
  sc_out<sc_lv<8> > dbus_out;
  sc_in<sc_logic> iore;
  sc_in<sc_logic> iowe;
  sc_out<sc_logic> out_en;
  sc_in<sc_logic> rxd;
  sc_out<sc_logic> rx_en;
  sc_out<sc_logic> txd;
  sc_out<sc_logic> tx_en;
  sc_out<sc_logic> txcirq;
  sc_in<sc_logic> txc_irqack;
  sc_out<sc_logic> udreirq;
  sc_out<sc_logic> rxcirq;
  sc_signal<sc_lv<8> > udr_tx = ;
  sc_signal<sc_lv<8> > udr_rx = ;
  sc_signal<sc_lv<8> > ubrr = ;
  sc_signal<sc_lv<8> > usr = ;
  sc_signal<sc_logic> usr_wr_en = ieee::std_logic_1164::'0';
  sc_signal<sc_lv<8> > ucr = ;
  sc_signal<sc_logic> ucr_wr_en = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> chr9_latched = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> txb8_latched = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_clk_en = ieee::std_logic_1164::'0';
  sc_signal<sc_lv<8> > sr_tx = ;
  sc_signal<sc_lv<8> > sr_tx_in = ;
  sc_signal<sc_logic> tx_in = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> nuart_tr_st0 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_tr_st1 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_tr_st2 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_tr_st3 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_tr_st4 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_tr_st5 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_tr_st6 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_tr_st7 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_tr_st8 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_tr_st9 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_tr_st10 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_tr_st11 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> flag_a = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> flag_b = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> udr_wr_en = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> udr_rd = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> usr_rd = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> ucr_rd = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> ubrr_rd = ieee::std_logic_1164::'0';
  sc_signal<sc_lv<4> > div16_cnt = ;
  sc_signal<sc_lv<4> > div16_in = ;
  sc_signal<sc_logic> div16_eq = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> ubrr_wr_en = ieee::std_logic_1164::'0';
  sc_signal<sc_lv<8> > baud_gen_cnt = ;
  sc_signal<sc_lv<8> > baud_gen_in = ;
  sc_signal<sc_logic> baud_gen_eq = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> baud_gen_out = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> nuart_rcdel_st0 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rcdel_st1 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rcdel_st2 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rcdel_st3 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rcdel_st4 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rcdel_st5 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rcdel_st6 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rcdel_st7 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rcdel_st8 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rcdel_st9 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rcdel_st10 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rcdel_st11 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rcdel_st12 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rcdel_st13 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rcdel_st14 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rcdel_st15 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rcdel_st16 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> nuart_rc_st0 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rc_st1 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rc_st2 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rc_st3 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rc_st4 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rc_st5 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rc_st6 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rc_st7 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rc_st8 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rc_st9 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rc_st10 = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> rxd_resynca = ieee::std_logic_1164::'1';
  sc_signal<sc_logic> rxd_resyncb = ieee::std_logic_1164::'1';
  sc_signal<sc_logic> detector_out = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> detector_a = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> detector_b = ieee::std_logic_1164::'0';
  sc_signal<sc_lv<10> > uart_rc_sr = ;
  sc_signal<sc_logic> uart_rc_sr7_in = ieee::std_logic_1164::'0';
  sc_signal<sc_logic> uart_rc_delay = ieee::std_logic_1164::'0';
  void baud_generator();
  void divide_by_16();
  void global_clock_enable();
  void ubrr_load();
  void udr_tx_load();
  void load_flags();
  void sr_tx_load_sift();
  void tx_out();
  void transmit_state_machine();
  void usr_udre();
  void usr_txc();
  void ucr_bits();
  void receiver();
  void receiver_shift();
  void rxd_resinc();
  void receiver_detect_a();
  void receiver_detect_b();
  void udr_rx_reg();
  void ucr_rxb8();
  void usr_bits();
  uart_rtl(const sc_module_name&);
};

uart_rtl::uart_rtl(const sc_module_name&)
{
  typedef uart_rtl SC_CURRENT_USER_MODULE;
  SC_THREAD(baud_generator);
  sensitive << cp2;
  sensitive << ireset;
  SC_THREAD(divide_by_16);
  sensitive << cp2;
  sensitive << ireset;
  SC_THREAD(global_clock_enable);
  sensitive << cp2;
  sensitive << ireset;
  SC_THREAD(ubrr_load);
  sensitive << cp2;
  sensitive << ireset;
  SC_THREAD(udr_tx_load);
  sensitive << cp2;
  sensitive << ireset;
  SC_THREAD(load_flags);
  sensitive << cp2;
  sensitive << ireset;
  SC_THREAD(sr_tx_load_sift);
  sensitive << cp2;
  sensitive << ireset;
  SC_THREAD(tx_out);
  sensitive << cp2;
  sensitive << ireset;
  SC_THREAD(transmit_state_machine);
  sensitive << cp2;
  sensitive << ireset;
  SC_THREAD(usr_udre);
  sensitive << cp2;
  sensitive << ireset;
  SC_THREAD(usr_txc);
  sensitive << cp2;
  sensitive << ireset;
  SC_THREAD(ucr_bits);
  sensitive << cp2;
  sensitive << ireset;
  SC_THREAD(receiver);
  sensitive << cp2;
  sensitive << ireset;
  SC_THREAD(receiver_shift);
  sensitive << cp2;
  sensitive << ireset;
  SC_THREAD(rxd_resinc);
  sensitive << cp2;
  sensitive << ireset;
  SC_THREAD(receiver_detect_a);
  sensitive << cp2;
  sensitive << ireset;
  SC_THREAD(receiver_detect_b);
  sensitive << cp2;
  sensitive << ireset;
  SC_THREAD(udr_rx_reg);
  sensitive << cp2;
  sensitive << ireset;
  SC_THREAD(ucr_rxb8);
  sensitive << cp2;
  sensitive << ireset;
  SC_THREAD(usr_bits);
  sensitive << cp2;
  sensitive << ireset;
  _V2SC::check_cyclelength("uart_rtl",1e+06);
}

void uart_rtl::baud_generator()
{
  while (true)
  {
    if (ireset == ieee::std_logic_1164::'0')
    {
      baud_gen_cnt = ;
      baud_gen_out = ieee::std_logic_1164::'0';
    }
    else if ((cp2 == ieee::std_logic_1164::'1') && )
    {
      baud_gen_cnt = baud_gen_in.read();
      baud_gen_out = baud_gen_eq.read();
    }
    wait();
  }
}
void uart_rtl::divide_by_16()
{
  while (true)
  {
    if (ireset == ieee::std_logic_1164::'0')
    {
      div16_cnt = ;
    }
    else if ((cp2 == ieee::std_logic_1164::'1') && )
    {
      if (baud_gen_out.read() == ieee::std_logic_1164::'1')
      {
        div16_cnt = div16_in.read();
      }
    }
    wait();
  }
}
void uart_rtl::global_clock_enable()
{
  while (true)
  {
    if (ireset == ieee::std_logic_1164::'0')
    {
      uart_clk_en = ieee::std_logic_1164::'0';
    }
    else if ((cp2 == ieee::std_logic_1164::'1') && )
    {
      uart_clk_en = div16_eq.read() && baud_gen_out.read();
    }
    wait();
  }
}
void uart_rtl::ubrr_load()
{
  while (true)
  {
    if (ireset == ieee::std_logic_1164::'0')
    {
      ubrr = ;
    }
    else if ((cp2 == ieee::std_logic_1164::'1') && )
    {
      if (ubrr_wr_en.read() == ieee::std_logic_1164::'1')
      {
        ubrr = dbus_in;
      }
    }
    wait();
  }
}
void uart_rtl::udr_tx_load()
{
  while (true)
  {
    if (ireset == ieee::std_logic_1164::'0')
    {
      udr_tx = ;
      chr9_latched = ieee::std_logic_1164::'0';
      txb8_latched = ieee::std_logic_1164::'0';
    }
    else if ((cp2 == ieee::std_logic_1164::'1') && )
    {
      if ((udr_wr_en.read() && (flag_a.read() || nuart_tr_st0.read())) == ieee::std_logic_1164::'1')
      {
        udr_tx = dbus_in;
        chr9_latched = chr9;
        txb8_latched = txb8;
      }
    }
    wait();
  }
}
void uart_rtl::load_flags()
{
  while (true)
  {
    if (ireset == ieee::std_logic_1164::'0')
    {
      flag_a = ieee::std_logic_1164::'0';
      flag_b = ieee::std_logic_1164::'0';
    }
    else if ((cp2 == ieee::std_logic_1164::'1') && )
    {
      flag_a = ((( ! flag_a.read()) && udr_wr_en.read()) && ( ! nuart_tr_st0.read())) || (flag_a.read() && ( ! (uart_tr_st1.read() && uart_clk_en.read())));
      flag_b = (( ! flag_b.read()) && (udr_wr_en.read() && (flag_a.read() || nuart_tr_st0.read()))) || (flag_b.read() && ( ! (uart_clk_en.read() && uart_tr_st11.read())));
    }
    wait();
  }
}
void uart_rtl::sr_tx_load_sift()
{
  while (true)
  {
    if (ireset == ieee::std_logic_1164::'0')
    {
      sr_tx = ;
    }
    else if ((cp2 == ieee::std_logic_1164::'1') && )
    {
      if (((((( ! flag_a.read()) && ( ! nuart_tr_st0.read())) && udr_wr_en.read()) || (uart_tr_st11.read() && uart_clk_en.read())) || ((nuart_tr_st0.read() && uart_clk_en.read()) && ( ! uart_tr_st1.read()))) == ieee::std_logic_1164::'1')
      {
        sr_tx = sr_tx_in.read();
      }
    }
    wait();
  }
}
void uart_rtl::tx_out()
{
  while (true)
  {
    if (ireset == ieee::std_logic_1164::'0')
    {
      txd = ieee::std_logic_1164::'1';
    }
    else if ((cp2 == ieee::std_logic_1164::'1') && )
    {
      if ((uart_clk_en.read() && (nuart_tr_st0.read() || flag_a.read())) == ieee::std_logic_1164::'1')
      {
        txd = tx_in.read();
      }
    }
    wait();
  }
}
void uart_rtl::transmit_state_machine()
{
  while (true)
  {
    if (ireset == ieee::std_logic_1164::'0')
    {
      nuart_tr_st0 = ieee::std_logic_1164::'0';
      uart_tr_st1 = ieee::std_logic_1164::'0';
      uart_tr_st2 = ieee::std_logic_1164::'0';
      uart_tr_st3 = ieee::std_logic_1164::'0';
      uart_tr_st4 = ieee::std_logic_1164::'0';
      uart_tr_st5 = ieee::std_logic_1164::'0';
      uart_tr_st6 = ieee::std_logic_1164::'0';
      uart_tr_st7 = ieee::std_logic_1164::'0';
      uart_tr_st8 = ieee::std_logic_1164::'0';
      uart_tr_st9 = ieee::std_logic_1164::'0';
      uart_tr_st10 = ieee::std_logic_1164::'0';
      uart_tr_st11 = ieee::std_logic_1164::'0';
    }
    else if ((cp2 == ieee::std_logic_1164::'1') && )
    {
      if (uart_clk_en.read() == ieee::std_logic_1164::'1')
      {
        nuart_tr_st0 = (( ! nuart_tr_st0.read()) && flag_a.read()) || (nuart_tr_st0.read() && ( ! (uart_tr_st11.read() && ( ! flag_b.read()))));
        uart_tr_st1 = ( ! uart_tr_st1.read()) && ((( ! nuart_tr_st0.read()) && flag_a.read()) || (uart_tr_st11.read() && flag_b.read()));
        uart_tr_st2 = uart_tr_st1.read();
        uart_tr_st3 = uart_tr_st2.read();
        uart_tr_st4 = uart_tr_st3.read();
        uart_tr_st5 = uart_tr_st4.read();
        uart_tr_st6 = uart_tr_st5.read();
        uart_tr_st7 = uart_tr_st6.read();
        uart_tr_st8 = uart_tr_st7.read();
        uart_tr_st9 = uart_tr_st8.read();
        uart_tr_st10 = uart_tr_st8.read() && chr9_latched.read();
        uart_tr_st11 = (uart_tr_st9.read() && ( ! chr9_latched.read())) || uart_tr_st10.read();
      }
    }
    wait();
  }
}
void uart_rtl::usr_udre()
{
  while (true)
  {
    if (ireset == ieee::std_logic_1164::'0')
    {
      udre = ieee::std_logic_1164::'1';
    }
    else if ((cp2 == ieee::std_logic_1164::'1') && )
    {
      udre = (udre && ( ! (udr_wr_en.read() && (flag_a.read() || nuart_tr_st0.read())))) || (( ! udre) && ((uart_tr_st11.read() && flag_b.read()) && uart_clk_en.read()));
    }
    wait();
  }
}
void uart_rtl::usr_txc()
{
  while (true)
  {
    if (ireset == ieee::std_logic_1164::'0')
    {
      txc = ieee::std_logic_1164::'0';
    }
    else if ((cp2 == ieee::std_logic_1164::'1') && )
    {
      txc = (( ! txc) && ((uart_tr_st11.read() && ( ! flag_b.read())) && uart_clk_en.read())) || (txc && ( ! ((udr_wr_en.read() || txc_irqack) || (usr_wr_en.read() && dbus_in[6]))));
    }
    wait();
  }
}
void uart_rtl::ucr_bits()
{
  while (true)
  {
    if (ireset == ieee::std_logic_1164::'0')
    {
       = ;
      ucr[0] = ieee::std_logic_1164::'0';
    }
    else if ((cp2 == ieee::std_logic_1164::'1') && )
    {
      if (ucr_wr_en.read() == ieee::std_logic_1164::'1')
      {
         = ;
        ucr[0] = dbus_in[0];
      }
    }
    wait();
  }
}
void uart_rtl::receiver()
{
  while (true)
  {
    if (ireset == ieee::std_logic_1164::'0')
    {
      nuart_rcdel_st0 = ieee::std_logic_1164::'0';
      uart_rcdel_st1 = ieee::std_logic_1164::'0';
      uart_rcdel_st2 = ieee::std_logic_1164::'0';
      uart_rcdel_st3 = ieee::std_logic_1164::'0';
      uart_rcdel_st4 = ieee::std_logic_1164::'0';
      uart_rcdel_st5 = ieee::std_logic_1164::'0';
      uart_rcdel_st6 = ieee::std_logic_1164::'0';
      uart_rcdel_st7 = ieee::std_logic_1164::'0';
      uart_rcdel_st8 = ieee::std_logic_1164::'0';
      uart_rcdel_st9 = ieee::std_logic_1164::'0';
      uart_rcdel_st10 = ieee::std_logic_1164::'0';
      uart_rcdel_st11 = ieee::std_logic_1164::'0';
      uart_rcdel_st12 = ieee::std_logic_1164::'0';
      uart_rcdel_st13 = ieee::std_logic_1164::'0';
      uart_rcdel_st14 = ieee::std_logic_1164::'0';
      uart_rcdel_st15 = ieee::std_logic_1164::'0';
      uart_rcdel_st16 = ieee::std_logic_1164::'0';
    }
    else if ((cp2 == ieee::std_logic_1164::'1') && )
    {
      if (baud_gen_out.read() == ieee::std_logic_1164::'1')
      {
        nuart_rcdel_st0 = (( ! nuart_rcdel_st0.read()) && ( ! rxd_resyncb.read())) || (nuart_rcdel_st0.read() && ( ! ((uart_rcdel_st10.read() && (detector_out.read() && ( ! nuart_rc_st0.read()))) || (uart_rcdel_st9.read() && uart_rc_st10.read()))));
        uart_rcdel_st1 = ( ! uart_rcdel_st1.read()) && ((( ! nuart_rcdel_st0.read()) && ( ! rxd_resyncb.read())) || (uart_rcdel_st16.read() && nuart_rc_st0.read()));
        uart_rcdel_st2 = uart_rcdel_st1.read();
        uart_rcdel_st3 = uart_rcdel_st2.read();
        uart_rcdel_st4 = uart_rcdel_st3.read();
        uart_rcdel_st5 = uart_rcdel_st4.read();
        uart_rcdel_st6 = uart_rcdel_st5.read();
        uart_rcdel_st7 = uart_rcdel_st6.read();
        uart_rcdel_st8 = uart_rcdel_st7.read();
        uart_rcdel_st9 = uart_rcdel_st8.read();
        uart_rcdel_st10 = (( ! uart_rcdel_st10.read()) && uart_rcdel_st9.read()) && ((( ! detector_out.read()) && ( ! nuart_rc_st0.read())) || (nuart_rc_st0.read() && ( ! uart_rc_st10.read())));
        uart_rcdel_st11 = uart_rcdel_st10.read();
        uart_rcdel_st12 = uart_rcdel_st11.read();
        uart_rcdel_st13 = uart_rcdel_st12.read();
        uart_rcdel_st14 = uart_rcdel_st13.read();
        uart_rcdel_st15 = uart_rcdel_st14.read();
        uart_rcdel_st16 = uart_rcdel_st15.read();
      }
    }
    wait();
  }
}
void uart_rtl::receiver_shift()
{
  while (true)
  {
    if (ireset == ieee::std_logic_1164::'0')
    {
      nuart_rc_st0 = ieee::std_logic_1164::'0';
      uart_rc_st1 = ieee::std_logic_1164::'0';
      uart_rc_st2 = ieee::std_logic_1164::'0';
      uart_rc_st3 = ieee::std_logic_1164::'0';
      uart_rc_st4 = ieee::std_logic_1164::'0';
      uart_rc_st5 = ieee::std_logic_1164::'0';
      uart_rc_st6 = ieee::std_logic_1164::'0';
      uart_rc_st7 = ieee::std_logic_1164::'0';
      uart_rc_st8 = ieee::std_logic_1164::'0';
      uart_rc_st9 = ieee::std_logic_1164::'0';
      uart_rc_st10 = ieee::std_logic_1164::'0';
      uart_rc_sr = ;
    }
    else if ((cp2 == ieee::std_logic_1164::'1') && )
    {
      if ((baud_gen_out.read() && uart_rcdel_st9.read()) == ieee::std_logic_1164::'1')
      {
        nuart_rc_st0 = (( ! nuart_rc_st0.read()) && ( ! rxd_resyncb.read())) || (nuart_rc_st0.read() && ( ! uart_rc_st10.read()));
        uart_rc_st1 = ( ! uart_rc_st1.read()) && (( ! nuart_rc_st0.read()) && ( ! rxd_resyncb.read()));
        uart_rc_st2 = uart_rc_st1.read();
        uart_rc_st3 = uart_rc_st2.read();
        uart_rc_st4 = uart_rc_st3.read();
        uart_rc_st5 = uart_rc_st4.read();
        uart_rc_st6 = uart_rc_st5.read();
        uart_rc_st7 = uart_rc_st6.read();
        uart_rc_st8 = uart_rc_st7.read();
        uart_rc_st9 = uart_rc_st8.read() && chr9;
        uart_rc_st10 = (uart_rc_st8.read() && ( ! chr9)) || uart_rc_st9.read();
         = ;
        uart_rc_sr[7] = uart_rc_sr7_in.read();
        uart_rc_sr[8] = uart_rc_sr[9];
        uart_rc_sr[9] = detector_out.read();
      }
    }
    wait();
  }
}
void uart_rtl::rxd_resinc()
{
  while (true)
  {
    if (ireset == ieee::std_logic_1164::'0')
    {
      rxd_resynca = ieee::std_logic_1164::'1';
      rxd_resyncb = ieee::std_logic_1164::'1';
    }
    else if ((cp2 == ieee::std_logic_1164::'1') && )
    {
      rxd_resynca = rxd;
      rxd_resyncb = rxd_resynca.read();
    }
    wait();
  }
}
void uart_rtl::receiver_detect_a()
{
  while (true)
  {
    if (ireset == ieee::std_logic_1164::'0')
    {
      detector_a = ieee::std_logic_1164::'0';
    }
    else if ((cp2 == ieee::std_logic_1164::'1') && )
    {
      if ((baud_gen_out.read() && uart_rcdel_st7.read()) == ieee::std_logic_1164::'1')
      {
        detector_a = rxd_resyncb.read();
      }
    }
    wait();
  }
}
void uart_rtl::receiver_detect_b()
{
  while (true)
  {
    if (ireset == ieee::std_logic_1164::'0')
    {
      detector_b = ieee::std_logic_1164::'0';
    }
    else if ((cp2 == ieee::std_logic_1164::'1') && )
    {
      if ((baud_gen_out.read() && uart_rcdel_st8.read()) == ieee::std_logic_1164::'1')
      {
        detector_b = rxd_resyncb.read();
      }
    }
    wait();
  }
}
void uart_rtl::udr_rx_reg()
{
  while (true)
  {
    if (ireset == ieee::std_logic_1164::'0')
    {
      udr_rx = ;
      fe = ieee::std_logic_1164::'0';
    }
    else if ((cp2 == ieee::std_logic_1164::'1') && )
    {
      if (((uart_rc_delay.read() && rxen) && ( ! rxc)) == ieee::std_logic_1164::'1')
      {
        udr_rx = ;
        fe =  ! uart_rc_sr[9];
      }
    }
    wait();
  }
}
void uart_rtl::ucr_rxb8()
{
  while (true)
  {
    if (ireset == ieee::std_logic_1164::'0')
    {
      rxb8 = ieee::std_logic_1164::'1';
    }
    else if ((cp2 == ieee::std_logic_1164::'1') && )
    {
      if ((((uart_rc_delay.read() && rxen) && ( ! rxc)) && chr9) == ieee::std_logic_1164::'1')
      {
        rxb8 = uart_rc_sr[8];
      }
    }
    wait();
  }
}
void uart_rtl::usr_bits()
{
  while (true)
  {
    if (ireset == ieee::std_logic_1164::'0')
    {
       = ;
      rxc = ieee::std_logic_1164::'0';
      dor = ieee::std_logic_1164::'0';
      uart_rc_delay = ieee::std_logic_1164::'0';
    }
    else if ((cp2 == ieee::std_logic_1164::'1') && )
    {
      rxc = (( ! rxc) && (uart_rc_delay.read() && rxen)) || (rxc && ( ! udr_rd.read()));
      dor = (( ! dor) && ((uart_rc_delay.read() && rxen) && rxc)) || (dor && ( ! ((uart_rc_delay.read() && rxen) && ( ! rxc))));
      uart_rc_delay = ( ! uart_rc_delay.read()) && ((baud_gen_out.read() && uart_rc_st10.read()) && uart_rcdel_st9.read());
    }
    wait();
  }
}
#endif
