//
//$Id: irq_onehot.cc,v 1.1 2003/07/16 19:45:03 nj Exp $
//
#include "irq_onehot.h"

//
// Sets one of 23 signals in irq_onehot_ack if irqack is set by avr_core
//
// sensitive << irqack << irqackad
void irq_onehot::execute()
{
  sc_lv<5> v_irqackad = irqackad.read();
  sc_uint<5> i_irqackad = v_irqackad;

  irq_onehot_ack0 = SC_LOGIC_0;
  irq_onehot_ack1 = SC_LOGIC_0;
  irq_onehot_ack2 = SC_LOGIC_0;
  irq_onehot_ack3 = SC_LOGIC_0;
  irq_onehot_ack4 = SC_LOGIC_0;
  irq_onehot_ack5 = SC_LOGIC_0;
  irq_onehot_ack6 = SC_LOGIC_0;
  irq_onehot_ack7 = SC_LOGIC_0;
  irq_onehot_ack8 = SC_LOGIC_0;
  irq_onehot_ack9 = SC_LOGIC_0;
  irq_onehot_ack10 = SC_LOGIC_0;
  irq_onehot_ack11 = SC_LOGIC_0;
  irq_onehot_ack12 = SC_LOGIC_0;
  irq_onehot_ack13 = SC_LOGIC_0;
  irq_onehot_ack14 = SC_LOGIC_0;
  irq_onehot_ack15 = SC_LOGIC_0;
  irq_onehot_ack16 = SC_LOGIC_0;
  irq_onehot_ack17 = SC_LOGIC_0;
  irq_onehot_ack18 = SC_LOGIC_0;
  irq_onehot_ack19 = SC_LOGIC_0;
  irq_onehot_ack20 = SC_LOGIC_0;
  irq_onehot_ack21 = SC_LOGIC_0;
  irq_onehot_ack22 = SC_LOGIC_0;

  if (irqack.read() == 1)
    {
      if (i_irqackad == 0) irq_onehot_ack0 = SC_LOGIC_1;
      if (i_irqackad == 1) irq_onehot_ack1 = SC_LOGIC_1;
      if (i_irqackad == 2) irq_onehot_ack2 = SC_LOGIC_1;
      if (i_irqackad == 3) irq_onehot_ack3 = SC_LOGIC_1;
      if (i_irqackad == 4) irq_onehot_ack4 = SC_LOGIC_1;
      if (i_irqackad == 5) irq_onehot_ack5 = SC_LOGIC_1;
      if (i_irqackad == 6) irq_onehot_ack6 = SC_LOGIC_1;
      if (i_irqackad == 7) irq_onehot_ack7 = SC_LOGIC_1;
      if (i_irqackad == 8) irq_onehot_ack8 = SC_LOGIC_1;
      if (i_irqackad == 9) irq_onehot_ack9 = SC_LOGIC_1;
      if (i_irqackad == 10) irq_onehot_ack10 = SC_LOGIC_1;
      if (i_irqackad == 11) irq_onehot_ack11 = SC_LOGIC_1;
      if (i_irqackad == 12) irq_onehot_ack12 = SC_LOGIC_1;
      if (i_irqackad == 13) irq_onehot_ack13 = SC_LOGIC_1;
      if (i_irqackad == 14) irq_onehot_ack14 = SC_LOGIC_1;
      if (i_irqackad == 15) irq_onehot_ack15 = SC_LOGIC_1;
      if (i_irqackad == 16) irq_onehot_ack16 = SC_LOGIC_1;
      if (i_irqackad == 17) irq_onehot_ack17 = SC_LOGIC_1;
      if (i_irqackad == 18) irq_onehot_ack18 = SC_LOGIC_1;
      if (i_irqackad == 19) irq_onehot_ack19 = SC_LOGIC_1;
      if (i_irqackad == 20) irq_onehot_ack20 = SC_LOGIC_1;
      if (i_irqackad == 21) irq_onehot_ack21 = SC_LOGIC_1;
      if (i_irqackad == 22) irq_onehot_ack22 = SC_LOGIC_1;
    }
}
